{
MEMOPOS 1.0.
By Martin Lundin.
martin@lundin.com.

This component gets the position from a RichEdit, a Memo or an Edit.

Properies:
Edit: TEdit;
GetFrom: (the_RichEdit,the_Memo,the_Edit);
Memo: TMemo;
RichEdit: TRichEdit;

Functions:
getCol: integer;
getRow: integer;
}
unit MemoPos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, StdCtrls;

type
    TGetFrom = (the_RichEdit,the_Memo,the_Edit);
  TMemoPos = class(TComponent)
  private
    FRichEdit: TRichEdit;
    FMemo: TMemo;
    FEdit: TEdit;
    FGetFrom: TGetFrom;
  protected
    { Protected declarations }
  public
    function getRow: integer;
    function getCol: integer;
  published
    property Edit: TEdit read FEdit write FEdit;
    property RichEdit: TRichEdit read FRichEdit write FRichEdit;
    property Memo: TMemo read FMemo write FMemo;
    property GetFrom: TGetFrom read FGetFrom write FGetFrom;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MartinL', [TMemoPos]);
end;

function TMemoPos.getRow: integer;
begin
if GetFrom = the_Memo then
Result:=SendMessage(Memo.Handle,EM_LINEFROMCHAR,Memo.SelStart,0)+1
else if GetFrom = the_RichEdit then
Result:=SendMessage(RichEdit.Handle,EM_LINEFROMCHAR,RichEdit.SelStart,0)+1
else
Result:=1;
end;

function TMemoPos.getCol: integer;
begin
if GetFrom = the_Memo then
Result:=Memo.SelStart-SendMessage(Memo.handle,EM_LINEINDEX,SendMessage(Memo.Handle,EM_LINEFROMCHAR,Memo.SelStart,0),0)+1
else if GetFrom = the_RichEdit then
Result:=RichEdit.SelStart-SendMessage(RichEdit.handle,EM_LINEINDEX,SendMessage(RichEdit.Handle,EM_LINEFROMCHAR,RichEdit.SelStart,0),0)+1
else
Result:=Edit.SelStart+1;
end;

end.
 